include("box2Dweb.js");

// see: http://blog.sethladd.com/2011/09/box2d-javascript-example-walkthrough.html
// http://stackoverflow.com/questions/9389279/is-there-a-way-in-box2dweb-to-output-position-x-of-an-object-to-console-log
// http://www.box2dflash.org/docs/2.1a/reference/
// http://www.box2dflash.org/docs/2.0.2/manual
// http://codingowl.com/
// collision listeners: http://buildnewgames.com/box2dweb/

function debug(printString){
    if (DebugMode){
    	print(printString + "\n");  
    }
}

// input format: arguments[0]
var out = []; // declare out as Global

var SCALE = 30;	// box2D recommended to scale from meters to pixels
var world;	// box2D, make global

function main(){

// DO setup here: ONCE ONLY *********************
    DebugMode = true; //example usage: debug("string" + var + "\n");

// ****** main function for LOOP ***************************************************************
    main = function(){
		world.Step(
    		1 / 60   //frame-rate
    		,  10       //velocity iterations
    		,  10       //position iterations
		);

		var myGroundPOS = [groundWidth, groundHeight, myGround.GetBody().GetPosition().x, myGround.GetBody().GetPosition().y];
        var myDropBoxPOS = [myDropBox.GetBody().GetPosition().x, myDropBox.GetBody().GetPosition().y, myDropBox.GetBody().GetAngle()];
        var myWheelPOS = [myWheel.GetPosition().x, myWheel.GetPosition().y, myWheel.GetAngle()];

		// note 'myDropPOS' is a fixture reference: 
		var myBodies = [
            JSON.stringify(myWheelPOS),
 		    JSON.stringify(myDropBoxPOS),
		    JSON.stringify(myGroundPOS)
        ];

		debug(JSON.stringify(myBodies) + "- YEAH " + "\n");
 
 		world.ClearForces();
		//out = [JSON.stringify(myBodies)];
        out = myBodies;
		return out;
	};


// ****** RUN ONCE FOR INIT ONLY ***************************************************************

 var b2Vec2 = Box2D.Common.Math.b2Vec2
  , b2BodyDef = Box2D.Dynamics.b2BodyDef
  , b2Body = Box2D.Dynamics.b2Body
  , b2FixtureDef = Box2D.Dynamics.b2FixtureDef
  , b2Fixture = Box2D.Dynamics.b2Fixture
  , b2World = Box2D.Dynamics.b2World
  , b2MassData = Box2D.Collision.Shapes.b2MassData
  , b2PolygonShape = Box2D.Collision.Shapes.b2PolygonShape
  , b2CircleShape = Box2D.Collision.Shapes.b2CircleShape
  , b2DebugDraw = Box2D.Dynamics.b2DebugDraw;

world = new b2World(
  new b2Vec2(0, -9.8)    //-9.8 gravity
  , true                 //allow sleep
);


var fixDef = new b2FixtureDef;  // CREATE GROUND *********************
fixDef.density = 1.0;
fixDef.friction = 0.5;
fixDef.restitution = 0.6;  // bounce

var bodyDef = new b2BodyDef;
bodyDef.type = b2Body.b2_staticBody;
       
// positions the center of the object (not upper left!)
bodyDef.position.x = 0.0;
bodyDef.position.y = -1.0;

fixDef.shape = new b2PolygonShape;
       
// half width, half height.
var groundHeight = .025;
var groundWidth = 2.0;
fixDef.shape.SetAsBox((groundWidth) / 2, (groundHeight) / 2);

var myGround = world.CreateBody(bodyDef).CreateFixture(fixDef);



var bodyDef1 = new b2BodyDef;  // CREATE polygonBOX *********************
bodyDef1.type = b2Body.b2_dynamicBody;

var fixDef1 = new b2FixtureDef;
fixDef1.shape = new b2PolygonShape;
fixDef1.shape.SetAsBox(
0.25 //half width
,0.25 //half height
);

bodyDef1.position.x = 0;
bodyDef1.position.y = 1;
var myDropBox = world.CreateBody(bodyDef1).CreateFixture(fixDef1);



var bodyDef2 = new b2BodyDef;  // CREATE circle *********************
bodyDef2.type = b2Body.b2_dynamicBody;
bodyDef2.position.Set(0.8,1);
bodyDef2.userData = 'obj';

var fixDef2 = new b2FixtureDef;
fixDef2.density = 10.0;
fixDef2.friction = .9;
fixDef2.restitution = .2;
fixDef2.shape = new b2CircleShape(0.25);

//var myWheel = world.CreateBody(bodyDef).CreateFixture(fixDef2);
var myWheel = world.CreateBody(bodyDef2);
myWheel.CreateFixture(fixDef2);

//Setting angular velocity to  2*360 degrees per second and Setting initial position to  x = 2 and y = 3 and Initial Angle to 20 degrees anticlockwise
myWheel.SetAngularVelocity(Math.PI*-4);  //*2 = 360 per sec
myWheel.SetPositionAndAngle(new b2Vec2(-0.75,1),-20*(Math.PI/180));

// other def
//fixDef.shape = new b2CircleShape(
//    Math.random() + 0.1 //radius
//);

}